﻿using System;
using System.Web;

namespace MyIP
{
    public class IpModule : IHttpModule
    {
        public void Init(HttpApplication context)
        {
            context.BeginRequest += Context_BeginRequest;
        }

        private void Context_BeginRequest(object sender, EventArgs e)
        {
            var context = HttpContext.Current;
            
            var request = context.Request;
            if (request.Path.StartsWith("/.")) return; //ACME

            context.ApplicationInstance.CompleteRequest();
            context.Response.ContentType = "text/ip-address";
            context.Response.Write(request.UserHostAddress ?? "0.0.0.0");
        }

        public void Dispose()
        {
        }
    }
}